#!/usr/bin/python
# -*- coding: UTF-8 -*-
# 并发执行检测文件

import threading
import os
import sys
import time
from datetime import datetime
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/app/")


class exeThread(threading.Thread):
    def __init__(self, param):
        threading.Thread.__init__(self)
        self.param = param
        self.flag = False
        self.result = ""
        self.special = False
        self.exeTime = 0

    def run(self):
        startTime = time.time()
        try:
            fileName = str(self.param['scriptName']).replace(".py", "")
            funcName = str(self.param['method'])
            funcParam = str(self.param['detectionParam'])
            if 'specialBeginTime' in self.param and 'specialEndTime' in self.param \
                    and self.param['specialBeginTime'] is not None and self.param['specialEndTime'] is not None:
                beginTime = self.param['specialBeginTime']
                endTime = self.param['specialEndTime']
                now = time.strftime('%H:%M:%S')
                if beginTime <= now <= endTime:
                    self.special = True
                    funcParam = str(self.param['specialDetectionParam'])
                    print("Special Detection: " + funcName + " param: " + funcParam)

            agentObj = __import__(fileName)
            func = getattr(agentObj, funcName)
            flag, result = func(funcParam)
        except Exception as e:
            flag, result = -1,e.message
        self.flag = flag
        self.result = result
        self.exeTime = "%.4f"%(time.time()-startTime)

    def get_result(self):
        return self.param, self.flag, self.result


def executeTask(task_array, sip):
    threads = []
    # 创建新线程
    for t in task_array:
        thread1 = exeThread(t)
        thread1.start()
        threads.append(thread1)

    # 等待所有线程完成
    for t in threads:
        t.join()

    # 获取结果
    result = []
    for t in threads:
        t.param['flag'] = t.flag
        t.param['result'] = t.result
        t.param['agentIp'] = sip
        t.param['special'] = t.special
        t.param['exeTime'] = t.exeTime
        result.append(t.param)
    return result
