#!/usr/bin/python
# coding=utf-8
# Author: feng
import os
import time
import sys
import urllib2
import ConfigParser as configparser
import logging
from logging import handlers


def getLocalConfig():
    # 读取本地配置文件
    cp = configparser.ConfigParser()
    server_conf_file = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/config/server.conf"
    cp.read(server_conf_file)
    return cp


class Logger(object):
    level_relations = {
        'debug': logging.DEBUG,
        'info': logging.INFO,
        'warning': logging.WARNING,
        'error': logging.ERROR,
        'crit': logging.CRITICAL
    }  # 日志级别关系映射

    def __init__(self, filename, level='info', when='D', backCount=2,
                 fmt="%(asctime)s %(message)s"):
        self.logger = logging.getLogger(filename)
        format_str = logging.Formatter(fmt)  # 设置日志格式
        self.logger.setLevel(self.level_relations.get(level))  # 设置日志级别
        sh = logging.StreamHandler()  # 往屏幕上输出
        sh.setFormatter(format_str)  # 设置屏幕上显示的格式
        th = handlers.TimedRotatingFileHandler(filename=filename, when=when, backupCount=backCount,
                                               encoding='utf-8')
        th.setFormatter(format_str)
        self.logger.addHandler(sh)
        self.logger.addHandler(th)


if __name__ == '__main__':
    cp = getLocalConfig()
    url = cp.get("server", "host") + cp.get("server", "heartbeat")

    if sys.platform.find("linux") != -1:
        log = Logger('/home/monitor4/client/log/heartbeat.log', level="info")
        while True:
            try:
                result = urllib2.urlopen(url).read()
                log.logger.info("success")
            except Exception as e:
                log.logger.info(e)
            time.sleep(10)
    else:
        heartbeatPath = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/config/pid.info"
        with open(heartbeatPath, 'w') as f:
            f.write(str(os.getpid()))
            f.flush()
        while True:
            try:
                result = urllib2.urlopen(url).read()
            except Exception as e:
                print e.message
            time.sleep(10)
